"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorBoundary = void 0;
const react_1 = __importDefault(require("react"));
class ErrorBoundary extends react_1.default.Component {
    constructor(props) {
        super(props);
        this.state = { hasError: false, error: null };
    }
    static getDerivedStateFromError(error) {
        return { hasError: true, error };
    }
    componentDidCatch(error, errorInfo) {
    }
    render() {
        // @ts-ignore
        if (this.state.hasError) {
            // @ts-ignore
            const error = this.state.error.message;
            return react_1.default.createElement("div", null,
                react_1.default.createElement("h1", null, "Error"),
                ";",
                react_1.default.createElement("pre", null, error),
                react_1.default.createElement("button", { onClick: () => this.setState({ hasError: false }) }, "Try again"));
        }
        // @ts-ignore
        return this.props.children;
    }
}
exports.ErrorBoundary = ErrorBoundary;
//# sourceMappingURL=components.js.map