"use strict";
// Copyright (c) Maarten A. Breddels
// Distributed under the terms of the Modified BSD License.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReactView = exports.ReactModel = void 0;
const base_1 = require("@jupyter-widgets/base");
const React = __importStar(require("react"));
const react_1 = require("react");
const ReactJsxRuntime = __importStar(require("react/jsx-runtime"));
const ReactReconcilerContants = __importStar(require("react-reconciler/constants"));
const ReactReconciler = __importStar(require("react-reconciler"));
const ReactDOM = __importStar(require("react-dom"));
// @ts-ignore
const ReactDOMClient = __importStar(require("react-dom/client"));
// @ts-ignore
require("../css/widget.css");
const utils_1 = require("./utils");
const version_1 = require("./version");
// import * as Babel from '@babel/standalone';
// TODO: find a way to ship es-module-shims with the widget
// @ts-ignore
// import 'es-module-shims';
const sucrase_1 = require("sucrase");
const components_1 = require("./components");
// @ts-ignore
// const react16Code = require('!!raw-loader!./react16.js');
// import react16Code from 'raw-loader!./react16.mjs';
// console.log(react16Code)
// this will do for now
let importShimLoaded = null;
function ensureImportShimLoaded() {
    return __awaiter(this, void 0, void 0, function* () {
        if (importShimLoaded == null) {
            importShimLoaded = utils_1.loadScript("module", "https://ga.jspm.io/npm:es-module-shims@1.7.0/dist/es-module-shims.js");
        }
        return yield importShimLoaded;
    });
}
function autoExternalReactResolve(id, parentUrl, resolve) {
    const shipsWith = (id == "react") || (id == "react-dom") || (id == "react/jsx-runtime") || (id == "react-dom/client") || (id == "react-reconciler") || (id == "react-reconciler/constants");
    const alreadyPatched = parentUrl.includes("?external=react,react-dom");
    const parentIsEsmSh = parentUrl.startsWith("https://esm.sh/");
    const isBlob = id.startsWith("blob:");
    if (!shipsWith && !id.includes("://") && !parentIsEsmSh) {
        id = "https://esm.sh/" + id;
    }
    if (!shipsWith && !alreadyPatched && !isBlob) {
        id = id + "?external=react,react-dom";
    }
    // console.log("resolve", id, parentUrl, resolve)
    return resolve(id, parentUrl);
}
// @ts-ignore
window.esmsInitOptions = { shimMode: true, resolve: (id, parentUrl, resolve) => autoExternalReactResolve(id, parentUrl, resolve)
};
let react18ESMUrls = null;
let react16ESMUrls = null;
function ensureReactSetup(version) {
    if (version == 18) {
        if (react18ESMUrls == null) {
            react18ESMUrls = {
                "react": utils_1.expose(React),
                "react-dom": utils_1.expose(ReactDOM),
                "react/jsx-runtime": utils_1.expose(ReactJsxRuntime),
                "react-dom/client": utils_1.expose(ReactDOMClient),
                "react-reconciler": utils_1.expose(ReactReconciler),
                "react-reconciler/constants": utils_1.expose(ReactReconcilerContants),
            };
        }
        return react18ESMUrls;
    }
    else if (version == 16) {
        if (react16ESMUrls == null) {
            // react16ESMUrls = {urlReact: expose(React16), urlReactDom: expose(ReactDOM16)};
        }
        return react16ESMUrls;
    }
}
class ReactModel extends base_1.DOMWidgetModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: ReactModel.model_name, _model_module: ReactModel.model_module, _model_module_version: ReactModel.model_module_version, _view_name: ReactModel.view_name, _view_module: ReactModel.view_module, _view_module_version: ReactModel.view_module_version, value: null });
        // TODO: ideally, we only compile code in the widget model, but the react hooks are
        // super convenient.
    }
}
exports.ReactModel = ReactModel;
ReactModel.serializers = Object.assign({}, base_1.DOMWidgetModel.serializers);
ReactModel.model_name = 'ReactModel';
ReactModel.model_module = version_1.MODULE_NAME;
ReactModel.model_module_version = version_1.MODULE_VERSION;
ReactModel.view_name = 'ReactView'; // Set to null if no view
ReactModel.view_module = version_1.MODULE_NAME; // Set to null if no view
ReactModel.view_module_version = version_1.MODULE_VERSION;
class ReactView extends base_1.DOMWidgetView {
    constructor() {
        super(...arguments);
        this.root = null;
    }
    render() {
        this.el.classList.add('jupyter-react-widget');
        // using babel is a bit of an art, so leaving this code for if we 
        // want to switch back to babel. However, babel is very large compared
        // to sucrase
        // Babel.registerPreset("my-preset", {
        //   presets: [
        //     [Babel.availablePresets["react"]],
        //     // [Babel.availablePresets["typescript"], { allExtensions: true }],
        //   ]
        // });
        // Babel.registerPlugin("importmap", pluginImport());
        // @ts-ignore
        // const React : any = {
        //   16: React16,
        //   18: React18,
        // }[this.model.get("react_version")];
        const Component = () => {
            // @ts-ignore
            // @ts-ignore
            const [_, setCounter] = react_1.useState(0);
            const forceRerender = () => {
                setCounter((x) => x + 1);
            };
            react_1.useEffect(() => {
                this.listenTo(this.model, 'change', forceRerender);
            }, []);
            const compiledCode = React.useMemo(() => {
                const code = this.model.get('_esm');
                if (this.model.get("debug")) {
                    console.log("original code:\n", code);
                }
                try {
                    // using babel:
                    // return Babel.transform(code,  { presets: ["react", "es2017"], plugins: ["importmap"] }).code;
                    // using sucrase:
                    let compiledCode = sucrase_1.transform(code, { transforms: ["jsx", "typescript"], filePath: "test.tsx" }).code;
                    if (this.model.get("debug")) {
                        console.log("compiledCode:\n", compiledCode);
                    }
                    return compiledCode;
                }
                catch (e) {
                    return e;
                }
            }, [this.model.get('_esm')]);
            const props = {};
            for (const event_name of this.model.attributes["_event_names"]) {
                const handler = (value, buffers) => {
                    if (buffers) {
                        const validBuffers = buffers instanceof Array &&
                            buffers[0] instanceof ArrayBuffer;
                        if (!validBuffers) {
                            console.warn('second argument is not an BufferArray[View] array');
                            buffers = undefined;
                        }
                    }
                    this.model.send({ event_name, data: value }, this.model.callbacks(this), buffers);
                };
                props["on_" + event_name] = handler;
            }
            for (const key of Object.keys(this.model.attributes)) {
                props[key] = this.model.get(key);
                props["on_" + key] = (value) => {
                    console.warn(`on_${key} is deprecated, use set_${key} instead`);
                    this.model.set(key, value);
                    this.touch();
                };
                props["set_" + key] = (value) => {
                    this.model.set(key, value);
                    this.touch();
                };
            }
            const [scope, setScope] = React.useState(null);
            const [muiFix, setMuiFix] = React.useState(null);
            React.useEffect(() => {
                let url = null;
                (() => __awaiter(this, void 0, void 0, function* () {
                    if (compiledCode instanceof Error) {
                        setScope(compiledCode);
                        return;
                    }
                    const reactImportMap = ensureReactSetup(this.model.get("react_version"));
                    yield ensureImportShimLoaded();
                    let finalCode = compiledCode;
                    // @ts-ignore
                    const importMapWidget = this.model.get("_import_map");
                    const importMap = {
                        "imports": Object.assign(Object.assign({}, reactImportMap), importMapWidget["imports"]),
                        "scopes": Object.assign({}, importMapWidget["scopes"])
                    };
                    // @ts-ignore
                    importShim.addImportMap(importMap);
                    const needsMuiFix = compiledCode.indexOf("@mui") !== -1;
                    if (needsMuiFix) {
                        setMuiFix(yield utils_1.setUpMuiFixModule());
                    }
                    url = URL.createObjectURL(new Blob([finalCode], { type: "text/javascript" }));
                    try {
                        // @ts-ignore
                        let module = yield importShim(url);
                        let name = this.model.get("name");
                        if (name && name.length > 0) {
                            // @ts-ignore
                            importShim.addImportMap({ "imports": { [name]: url } });
                        }
                        setScope(module);
                    }
                    catch (e) {
                        setScope(e);
                    }
                }))();
                return () => {
                    if (url) {
                        URL.revokeObjectURL(url);
                    }
                };
            }, [compiledCode]);
            if (!scope) {
                return React.createElement("div", null, "Loading...");
            }
            else {
                if (scope instanceof Error) {
                    return React.createElement("pre", null, scope.message);
                }
                else {
                    if (scope.default === undefined) {
                        return React.createElement("div", null, "Missing default component");
                    }
                    else {
                        if (this.model.get("debug")) {
                            console.log("props", props);
                        }
                        // @ts-ignore
                        let el = React.createElement(scope.default, props);
                        // check if @mui string is in compiledCode
                        // if so, we need to wrap the element in a style wrapper
                        // @ts-ignore
                        const needsMuiFix = compiledCode.indexOf("@mui") !== -1;
                        if (this.model.get("debug")) {
                            console.log("needsMuiFix", needsMuiFix);
                        }
                        if (needsMuiFix) {
                            el = muiFix.styleWrapper(el);
                        }
                        return el;
                    }
                }
            }
        };
        if (this.model.get("react_version") === 18) {
            this.root = ReactDOMClient.createRoot(this.el);
            this.root.render(React.createElement(components_1.ErrorBoundary, null,
                React.createElement(Component, null)));
        }
        else {
            // @ts-ignore
            // ReactDOM16.render(<Component></Component>, this.el);
        }
    }
    remove() {
        var _a;
        (_a = this.root) === null || _a === void 0 ? void 0 : _a.unmount();
    }
}
exports.ReactView = ReactView;
//# sourceMappingURL=widget.js.map